__license__ = '''
sodom
Copyright (C) 2023  Dmitry Protasov (inbox@protaz.ru)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as
published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General
Public License along with this program.  If not, see <https://www.gnu.org/licenses/>.
'''

from sodom.elements import NormalElement as __NormalElement
from sodom.elements import VoidElement as __VoidElement
from sodom import literals as __literals
from sodom.partial import prebuild as __prebuild


##### NORMAL #####
a = __prebuild(__NormalElement[__literals.A])
abbr = __prebuild(__NormalElement[__literals.ABBR])
acronym = __prebuild(__NormalElement[__literals.ACRONYM])
address = __prebuild(__NormalElement[__literals.ADDRESS])
article = __prebuild(__NormalElement[__literals.ARTICLE])
aside = __prebuild(__NormalElement[__literals.ASIDE])
audio = __prebuild(__NormalElement[__literals.AUDIO])
b = __prebuild(__NormalElement[__literals.B])
bdi = __prebuild(__NormalElement[__literals.BDI])
bdo = __prebuild(__NormalElement[__literals.BDO])
big = __prebuild(__NormalElement[__literals.BIG])
blockquote = __prebuild(__NormalElement[__literals.BLOCKQUOTE])
body = __prebuild(__NormalElement[__literals.BODY])
button = __prebuild(__NormalElement[__literals.BUTTON])
canvas = __prebuild(__NormalElement[__literals.CANVAS])
caption = __prebuild(__NormalElement[__literals.CAPTION])
center = __prebuild(__NormalElement[__literals.CENTER])
cite = __prebuild(__NormalElement[__literals.CITE])
code = __prebuild(__NormalElement[__literals.CODE])
colgroup = __prebuild(__NormalElement[__literals.COLGROUP])
data = __prebuild(__NormalElement[__literals.DATA])
datalist = __prebuild(__NormalElement[__literals.DATALIST])
dd = __prebuild(__NormalElement[__literals.DD])
del_ = __prebuild(__NormalElement[__literals.DEL])
details = __prebuild(__NormalElement[__literals.DETAILS])
dfn = __prebuild(__NormalElement[__literals.DFN])
dialog = __prebuild(__NormalElement[__literals.DIALOG])
dir_ = __prebuild(__NormalElement[__literals.DIR])
div = __prebuild(__NormalElement[__literals.DIV])
dl = __prebuild(__NormalElement[__literals.DL])
dt = __prebuild(__NormalElement[__literals.DT])
em = __prebuild(__NormalElement[__literals.EM])
fieldset = __prebuild(__NormalElement[__literals.FIELDSET])
figcaption = __prebuild(__NormalElement[__literals.FIGCAPTION])
figure = __prebuild(__NormalElement[__literals.FIGURE])
font = __prebuild(__NormalElement[__literals.FONT])
footer = __prebuild(__NormalElement[__literals.FOOTER])
form = __prebuild(__NormalElement[__literals.FORM])
frame = __prebuild(__NormalElement[__literals.FRAME])
frameset = __prebuild(__NormalElement[__literals.FRAMESET])
h1 = __prebuild(__NormalElement[__literals.H1])
h2 = __prebuild(__NormalElement[__literals.H2])
h3 = __prebuild(__NormalElement[__literals.H3])
h4 = __prebuild(__NormalElement[__literals.H4])
h5 = __prebuild(__NormalElement[__literals.H5])
h6 = __prebuild(__NormalElement[__literals.H6])
head = __prebuild(__NormalElement[__literals.HEAD])
header = __prebuild(__NormalElement[__literals.HEADER])
hgroup = __prebuild(__NormalElement[__literals.HGROUP])
html = __prebuild(__NormalElement[__literals.HTML])
i = __prebuild(__NormalElement[__literals.I])
iframe = __prebuild(__NormalElement[__literals.IFRAME])
image = __prebuild(__NormalElement[__literals.IMAGE])
ins = __prebuild(__NormalElement[__literals.INS])
kbd = __prebuild(__NormalElement[__literals.KBD])
label = __prebuild(__NormalElement[__literals.LABEL])
legend = __prebuild(__NormalElement[__literals.LEGEND])
li = __prebuild(__NormalElement[__literals.LI])
main = __prebuild(__NormalElement[__literals.MAIN])
map_ = __prebuild(__NormalElement[__literals.MAP])
mark = __prebuild(__NormalElement[__literals.MARK])
marquee = __prebuild(__NormalElement[__literals.MARQUEE])
menu = __prebuild(__NormalElement[__literals.MENU])
menuitem = __prebuild(__NormalElement[__literals.MENUITEM])
meter = __prebuild(__NormalElement[__literals.METER])
nav = __prebuild(__NormalElement[__literals.NAV])
nobr = __prebuild(__NormalElement[__literals.NOBR])
noembed = __prebuild(__NormalElement[__literals.NOEMBED])
noframes = __prebuild(__NormalElement[__literals.NOFRAMES])
noscript = __prebuild(__NormalElement[__literals.NOSCRIPT])
object_ = __prebuild(__NormalElement[__literals.OBJECT])
ol = __prebuild(__NormalElement[__literals.OL])
optgroup = __prebuild(__NormalElement[__literals.OPTGROUP])
option = __prebuild(__NormalElement[__literals.OPTION])
output = __prebuild(__NormalElement[__literals.OUTPUT])
p = __prebuild(__NormalElement[__literals.P])
picture = __prebuild(__NormalElement[__literals.PICTURE])
plaintext = __prebuild(__NormalElement[__literals.PLAINTEXT])
portal = __prebuild(__NormalElement[__literals.PORTAL])
pre = __prebuild(__NormalElement[__literals.PRE])
progress = __prebuild(__NormalElement[__literals.PROGRESS])
q = __prebuild(__NormalElement[__literals.Q])
rb = __prebuild(__NormalElement[__literals.RB])
rp = __prebuild(__NormalElement[__literals.RP])
rt = __prebuild(__NormalElement[__literals.RT])
rtc = __prebuild(__NormalElement[__literals.RTC])
ruby = __prebuild(__NormalElement[__literals.RUBY])
s = __prebuild(__NormalElement[__literals.S])
samp = __prebuild(__NormalElement[__literals.SAMP])
script = __prebuild(__NormalElement[__literals.SCRIPT])
search = __prebuild(__NormalElement[__literals.SEARCH])
section = __prebuild(__NormalElement[__literals.SECTION])
select = __prebuild(__NormalElement[__literals.SELECT])
slot = __prebuild(__NormalElement[__literals.SLOT])
small = __prebuild(__NormalElement[__literals.SMALL])
span = __prebuild(__NormalElement[__literals.SPAN])
strike = __prebuild(__NormalElement[__literals.STRIKE])
strong = __prebuild(__NormalElement[__literals.STRONG])
style = __prebuild(__NormalElement[__literals.STYLE])
sub = __prebuild(__NormalElement[__literals.SUB])
summary = __prebuild(__NormalElement[__literals.SUMMARY])
sup = __prebuild(__NormalElement[__literals.SUP])
table = __prebuild(__NormalElement[__literals.TABLE])
tbody = __prebuild(__NormalElement[__literals.TBODY])
td = __prebuild(__NormalElement[__literals.TD])
template = __prebuild(__NormalElement[__literals.TEMPLATE])
textarea = __prebuild(__NormalElement[__literals.TEXTAREA])
tfoot = __prebuild(__NormalElement[__literals.TFOOT])
th = __prebuild(__NormalElement[__literals.TH])
thead = __prebuild(__NormalElement[__literals.THEAD])
time = __prebuild(__NormalElement[__literals.TIME])
title = __prebuild(__NormalElement[__literals.TITLE])
tr = __prebuild(__NormalElement[__literals.TR])
tt = __prebuild(__NormalElement[__literals.TT])
u = __prebuild(__NormalElement[__literals.U])
ul = __prebuild(__NormalElement[__literals.UL])
var = __prebuild(__NormalElement[__literals.VAR])
video = __prebuild(__NormalElement[__literals.VIDEO])
xmp = __prebuild(__NormalElement[__literals.XMP])


##### VOID #####
area = __prebuild(__VoidElement[__literals.AREA])
base = __prebuild(__VoidElement[__literals.BASE])
br = __prebuild(__VoidElement[__literals.BR])
col = __prebuild(__VoidElement[__literals.COL])
embed = __prebuild(__VoidElement[__literals.EMBED])
hr = __prebuild(__VoidElement[__literals.HR])
img = __prebuild(__VoidElement[__literals.IMG])
input_ = __prebuild(__VoidElement[__literals.INPUT])
link = __prebuild(__VoidElement[__literals.LINK])
meta = __prebuild(__VoidElement[__literals.META])
param = __prebuild(__VoidElement[__literals.PARAM])
source = __prebuild(__VoidElement[__literals.SOURCE])
track = __prebuild(__VoidElement[__literals.TRACK])
wbr = __prebuild(__VoidElement[__literals.WBR])


##### INPUT #####
input_datetime_local = __prebuild(input_, type='datetime-local')
input_button = __prebuild(input_, type='button')
input_checkbox = __prebuild(input_, type='checkbox')
input_color = __prebuild(input_, type='color')
input_date = __prebuild(input_, type='date')
input_email = __prebuild(input_, type='email')
input_file = __prebuild(input_, type='file')
input_hidden = __prebuild(input_, type='hidden')
input_image = __prebuild(input_, type='image')
input_month = __prebuild(input_, type='month')
input_number = __prebuild(input_, type='number')
input_password = __prebuild(input_, type='password')
input_radio = __prebuild(input_, type='radio')
input_range = __prebuild(input_, type='range')
input_reset = __prebuild(input_, type='reset')
input_search = __prebuild(input_, type='search')
input_submit = __prebuild(input_, type='submit')
input_tel = __prebuild(input_, type='tel')
input_text = __prebuild(input_, type='text')
input_time = __prebuild(input_, type='time')
input_url = __prebuild(input_, type='url')
input_week = __prebuild(input_, type='week')
